function addGrass() {
        useBrick("brick4x4fData");
        shiftBrickDown(1);
        shiftBrickDown(0);
        shiftBrickThirdDown(1);
        shiftBrickThirdDown(0);    
        shiftBrickThirdDown(1);
        shiftBrickThirdDown(0);       
        plantBrick(1);
        plantBrick(0);
        shiftBrickUp(1);
        shiftBrickUp(0);
        shiftBrickThirdUp(1); 
        shiftBrickThirdUp(0);    
        shiftBrickThirdUp(1); 
        shiftBrickThirdUp(0);  
}
 
function addTrees(%tf, %g) {
    if(getRandom(0, %tf) == 1) {
        shiftBrickUp(1);
        shiftBrickUp(1);
        if(%g == 1) {
            shiftBrickThirdUp(1);
            shiftBrickThirdUp(0);
        }
        shiftBrickUp(0);
        plantBrick(1);
        plantBrick(0);
        if(%g == 1) {
            shiftBrickThirdDown(1);
            shiftBrickThirdDown(0);
        }
        shiftBrickDown(1);
        shiftBrickDown(1);
        shiftBrickDown(0);
    }
}
 
function poseWater(%i) { if(%i==1) {
	useBrick("brick8xWaterData");
	usePaint("0 1 1 .7");
	shift(2, "up"); shift(1,"tdown");
	shift(2, "right"); shift(2,"away"); } if(%i == 0) {
	shift(2, "toward"); shift(2, "left");
	shift(1, "tup"); shift(2, "down"); }
}
 
function addLava() {
 
            usePaint("1 .5 0 .7");
            useBrick("brick8xWaterData");
            shiftBrickUp(1); shiftBrickUp(0);
            shiftBrickUp(1); shiftBrickUp(0);
            shiftBrickThirdDown(1); shiftBrickThirdDown(0);
            shiftBrickRight(1); shiftBrickRight(0);
            shiftBrickRight(1); shiftBrickRight(0);
            shiftBrickAway(1); shiftBrickAway(0);
            shiftBrickAway(1); shiftBrickAway(0);
            placeBrick();
}
function addChest(%g,%cc) {
    useBrick("brickTreasureChestData");
    usePaint(%cc);
    shiftBrickThirdDown(1); shiftBrickThirdDown(0);
    shiftBrickThirdDown(1); shiftBrickThirdDown(0);
    if(%g == 0) {
        shiftBrickThirdDown(1); shiftBrickThirdDown(0);
    }
    placeBrick();
    useBrick("brick4xCubeData");
    shiftBrickUp(1); shiftBrickUp(0);
    if(%g == 1) {
        shiftBrickThirdDown(1); shiftBrickThirdDown(0);
    }
    
}

function addTunnel() {
	useBrick("brick1x1x5Data");
	usePaint(".32 .2 .14 1");
	shiftBrickUp(1); shiftBrickUp(0); 
	shiftBrickThirdDown(1); shiftBrickThirdDown(0);
	shiftBrickLeft(1); shiftBrickLeft(0);
	shiftBrickTowards(1); shiftBrickTowards(0);
	shiftBrickTowards(1); shiftBrickTowards(0);
	placeBrick();
	shiftBrickAway(1); shiftBrickAway(0);
	shiftBrickAway(1); shiftBrickAway(0);
}

function addRocks(%g) {
    usePaint(".5 .5 .5 1");
	%randomRock = getRandom(1,4);
	
	switch(%randomRock) {
	
	case 1:
	useBrick("brick2x2data");
	    shiftBrickDown(1); shiftBrickDown(0);
		
    if(%g == 0) {
	    
        shiftBrickThirdDown(1); shiftBrickThirdDown(0);
		placeBrick();
		    useBrick("brick4xCubeData");
    shiftBrickUp(1); shiftBrickUp(0); shiftBrickThirdUp(1); shiftBrickThirdUp(0);
    } else if(%g == 1) {
        placeBrick();
		useBrick("brick4xCubeData");
		shiftBrickUp(1); shiftBrickUp(0);
		}
		case 2:
		useBrick("brick2x2data");
	    shiftBrickDown(1); shiftBrickDown(0);
    if(%g == 0) {
        shiftBrickThirdDown(1); shiftBrickThirdDown(0);
		advancedRock0();
    } else if(%g == 1) {
	
        advancedRock0();
		shift(1,"tdown");
	

    }
    
	case 3:
		useBrick("brick2x2data");
	    shiftBrickDown(1); shiftBrickDown(0);
    if(%g == 0) {
        shiftBrickThirdDown(1); shiftBrickThirdDown(0);
		advancedRock1();
    } else if(%g == 1) {
	
        advancedRock1();
		shift(1,"tdown");
	

    }
	
	case 4:
		useBrick("brick1x1fdata");
		shift(2,"down");
		    if(%g == 0) {
					shift(1,"tup");
		advancedRock3();
    } else if(%g == 1) {
			shift(2,"tup");
        advancedRock3();
		shift(1,"tdown");
	

    }
}
}


function advancedRock0() {

		shiftBrickLeft(1); shiftBrickTowards(1); shiftBrickLeft(0); shiftBrickTowards(0); 
		placeBrick();
		shiftBrickUp(1); shiftBrickUp(0); 
		shiftBrickRight(1); shiftBrickAway(1); shiftBrickRight(0); shiftBrickAway(0);
		placeBrick();
		shiftBrickDown(1); shiftBrickDown(0); 
		shiftBrickRight(1); shiftBrickAway(1); shiftBrickRight(0); shiftBrickAway(0);
		placeBrick();
		useBrick("brick4xCubeData");
		shiftBrickTowards(1); shiftBrickTowards(0); 
		shiftBrickLeft(1); shiftBrickLeft(0); shiftBrickUp(1); shiftBrickUp(0); 
		shift(1,"tup");
	}
	

	function advancedRock1() {

		shift(1,"left"); shift(1,"forward"); //This technically shouldn't work because "forward" is not a case, but TorqueScript defies logic. It doesn't work correctly if you remove it, try it if you don't believe me.
		placeBrick();
		shiftBrickUp(1); shiftBrickUp(0); 
		shift(1,"right"); shift(1,"back"); 
		placeBrick();
		shiftBrickDown(1); shiftBrickDown(0); 
		shift(1,"right"); shift(1,"back"); 
		placeBrick();
		useBrick("brick4xCubeData");
		shift(1,"left"); shift(1,"forward");
		shiftBrickUp(1); shiftBrickUp(0); 
		shift(1,"tup");
	}
	
	function advancedRock2() {
	
		shift(1,"left"); 
		placeBrick();
		shift(2,"right"); 
		shift(1,"back");
		placeBrick();
		useBrick("brick4xCubeData");
		shift(1,"left"); shift(1,"forward");
		shiftBrickUp(1); shiftBrickUp(0);
		shift(2,"tup");
	}
		
		function advancedRock3() {
	
		shift(1,"left");
		shift(1,"back");
		placeBrick();
		shift(2,"right"); 
		shift(1,"forward");
		placeBrick();
		useBrick("brick4xCubeData");
		shift(1,"left");
		shiftBrickUp(1); shiftBrickUp(0);
		shift(2,"tup");
	}
	
	
        function addFlower(%g, %c1, %c2, %c3) {
        useBrick("brick1x1fRoundData");
        usePaint(".5 .9 .5 1");
                %randomFlower = getRandom(1,3);
        switch(%randomFlower) {
                case 1: if(%g==0) { shift(2,"down"); shiftp(1,"tup"); usePaint(%c1); shiftp(1,"tup"); } else if(%g==1) { shift(1,"down"); shiftp(1,"tdown"); usePaint(%c1); shiftp(1,"tup"); }
                case 2: if(%g==0) { shift(2,"down"); shiftp(1,"tup"); usePaint(%c2); shiftp(1,"tup"); } else if(%g==1) { shift(1,"down"); shiftp(1,"tdown"); usePaint(%c2); shiftp(1,"tup"); }
                case 3: if(%g==0) { shift(2,"down"); shiftp(1,"tup"); usePaint(%c3); shiftp(1,"tup"); } else if(%g==1) { shift(1,"down"); shiftp(1,"tdown"); usePaint(%c3); shiftp(1,"tup"); }
                }
        useBrick("brick4xCubeData");
        if(%g==0) { shift(2,"up"); shift(1,"tup"); } else if(%g==1) { shift(1,"up"); }
}

